#include "bsplinesurface.h"
#include "bspline.h"
#include <malloc.h>
#include <stdio.h>


struct SsurfaceBspline {
  
  /* a compléter */
  
  int nbPtsControleU; /* Nombre du points en U du maillage controle de la surface */
  int nbPtsControleV; /* Nombre du points en V du maillage controle de la surface */
  GLfloat *ptsControle; /* Points du maillage de controle */
  GLuint *indexMaillageControle; /* Tableau d'index pour afficher le maillage de controle avec des quadrilatères */
  
  
  int nbPtsU; /* nombre de points du maillage de la surface en u */
  int nbPtsV; /* nombre de points du maillage de la surface en v */
  GLfloat *ptsMaillage; /* Points du maillage représentant la surface */
  GLfloat *normalesMaillage; /* Normales aux points du maillage représentant la surface */
  GLuint *indexMaillage; /* Tableau d'index pour mailler les points du maillages avec des quadrilatères */
  
};


void calculNormalesMaillageSurfaceBspline (SurfaceBspline s) {

  
  
}

SurfaceBspline creerSurfaceBsplineUniforme (GLfloat *ptsControle, int nbPtsControle, int k) {
  
  SurfaceBspline s = (SurfaceBspline) malloc (sizeof(struct SsurfaceBspline));
  
  /* a completer */
  
  return s;
}

void evalSurfaceBspline (SurfaceBspline s, float u, Point p) {
  
  /* a completer */
  
}

void calculMaillageSurfaceBspline (SurfaceBspline s, int nbPtsU, int nbPtsV){
  
  /* a completer */
  
}


/* affichage du polygone de contrôle en filaire */
void affichePolyControleSurfaceBspline (SurfaceBspline s){

  glPolygonMode (GL_FRONT_AND_BACK, GL_LINE);
  glLineWidth (2.);
  
    glColor3f(1.,0,0); /* choix de la couleur d'affichage du maillage de controle de la surface */
    glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3,GL_FLOAT,0,s->ptsControle);
    glDrawElements(GL_QUADS,(s->nbPtsControleU-1)*(s->nbPtsControleV-1)*4,GL_UNSIGNED_INT,s->indexMaillageControle);
    glDisableClientState(GL_VERTEX_ARRAY);
  
    
  glLineWidth(1.);
  glPolygonMode (GL_FRONT_AND_BACK, GL_FILL);
}

void afficheSurfaceBspline (SurfaceBspline s){

    glColor3f(0,1,0); /* choix de la couleur d'affichage de la surface */
    glEnableClientState(GL_VERTEX_ARRAY);
    glVertexPointer(3,GL_FLOAT,0,s->ptsMaillage);
    glEnableClientState(GL_NORMAL_ARRAY);
    glNormalPointer(GL_FLOAT, 0, s->normalesMaillage);
    glDrawElements(GL_QUADS,(s->nbPtsU-1)*(s->nbPtsV-1)*4,GL_UNSIGNED_INT,s->indexMaillage);
    glDisableClientState(GL_VERTEX_ARRAY);
    glDisableClientState(GL_NORMAL_ARRAY);
  
}


