#ifndef BSPLINE_SURFACE
#define BSPLINE_SURFACE

#include <GL/gl.h>
#include "myMath.h"

typedef struct SsurfaceBspline *SurfaceBspline;

SurfaceBspline creerSurfaceBsplineUniforme (GLfloat *ptsControle, int nbPtsControle, int k);

void evalSurfaceBspline (SurfaceBspline s, float u, Point p);

void calculMaillageSurfaceBspline (SurfaceBspline b, int nbPtsU, int nbPtsV);

void affichePolyControleSurfaceBspline (SurfaceBspline b);

void afficheSurfaceBspline (SurfaceBspline b);

#endif